//effects
//DEATH PUNCH!!!




//punch trail
datablock ParticleData(MonepunchTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 1000;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//textureName		= "base/data/particles/corona2";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
	colors[0]	= "1 1 1 1.0";
	colors[1]	= "1 1 1 1.0";
	colors[2]	= "1 0.75 0.05 0.5";
	colors[3]	= "1 0.75 0.05 0.0";
	sizes[0]	= 0.1;
	sizes[1]	= 15;
	sizes[2]	= 5;
	sizes[3]	= 0;
	times[0]	= 0.0;
	times[1]	= 0.1;
	times[2]	= 0.7;
	times[3]	= 1.0;
};

datablock ParticleEmitterData(MonepunchTrailEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = MonepunchTrailParticle;
};




//effects
datablock ParticleData(MonepunchExplosionParticle)
{
   dragCoefficient      = 10;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 300;
   textureName          = "base/data/particles/chunk";
	spinSpeed		= 10.0;
	spinRandomMin		= -90.0;
	spinRandomMax		= 90.0;
   colors[0]     = "1.0 0.5 0.3 1.0";
   colors[1]     = "1.0 0.5 0.3 0.0";
   sizes[0]      = 10.0;
   sizes[1]      = 17.0;

   useInvAlpha = true;  
};

datablock ParticleEmitterData(MonepunchExplosionEmitter)
{
   lifetimeMS	    = 33;
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 100;
   velocityVariance = 1.0;
   ejectionOffset   = 1.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MonepunchExplosionParticle";

   uiName = "Monepunch Hit";
};

datablock ExplosionData(MonepunchExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;

   soundProfile = MheavypunchHitSound;

   particleEmitter = MonepunchExplosionEmitter;
   particleDensity = 60;
   particleRadius = 2.5;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 1.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 0;
   lightStartColor = "1.0 0.2 0.0";
   lightEndColor = "0 0 0";


   damageRadius = 1;
   radiusDamage = 1;

   impulseRadius = 25;
   impulseForce = 4000;
	
};


//projectile
datablock ProjectileData(MonepunchProjectile)
{
   directDamage        = 1000;
   impactImpulse       = 3000;
   verticalImpulse     = 1000;
   directDamageType  = $DamageType::Melee;
   radiusDamageType  = $DamageType::Melee;
   explosion           = MonepunchExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0.5 0 0";

   uiName = "Monepunch Punch";
};



//////////
// item //
//////////
datablock ItemData(MonepunchItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "base/data/shapes/empty.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "ONE PUNCH";
	iconName = "./icon_Mpunch";
	doColorShift = true;
	colorShiftColor = "1.000 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = MonepunchImage;
	canDrop = false;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(MonepunchImage)
{
   // Basic Item properties
   shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0.0 0.5 -0.75";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = MonepunchItem;
   ammo = " ";
   projectile = MonepunchProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.2;
	stateSequence[0]                = "Activate";
	stateTransitionOnTimeout[0]      = "Ready";

	//when the trigger is held go to prefire.
	stateName[1]                     = "Ready";
	stateSequence[1]                = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	//stateSequence[2]                = "Ready";
	//stateAllowImageChange[2]        = false;
	stateTransitionOnTriggerUp[2]	= "Fire";
	stateWaitForTimeout[2]		= true;
	stateTransitionOnTimeout[2]     = "PostFire";
	stateTimeoutValue[2]            = 0.05;

	//keeps cyling the PreFire thing.
	stateName[3]			= "PostFire";
	stateScript[3]                  = "onPostFire";
	stateSequence[3]                = "Ready";
	stateAllowImageChange[3]        = false;
	stateTransitionOnTriggerUp[3]	= "StopFire";
	stateWaitForTimeout[3]		= true;
	stateTransitionOnTimeout[3]     = "PostFire";
	stateTimeoutValue[3]            = 0.05;
	//stateSound[3]                    = MpunchDrawSound; //a whoosh sound effect yeeeee
   	stateEmitter[3]					= MonepunchTrailEmitter;
	stateEmitterTime[3]				= 0.2;
	//stateEmitterNode[3]				= "muzzleNode";

//keeps cyling the PreFire thing.
	//stateName[3]			= "PreFireB";
	//stateSequence[3]                = "Ready";
	//stateAllowImageChange[3]        = false;
	//stateTransitionOnTriggerUp[3]	= "StopFire";
	//stateWaitForTimeout[3]		= true;
	//stateTransitionOnTimeout[3]     = "PreFireA";
	//stateTimeoutValue[3]            = 0.05;
	//stateScript[3]                  = "onPreFireB";
	//stateSound[3]                    = MpunchDrawSound; //a whoosh sound effect yeeeee
   	//stateEmitter[3]					= gunFlashEmitter;
	//stateEmitterTime[3]				= 0.05;
	//stateEmitterNode[3]				= "muzzleNode";


	//fire the projectile for 0.2 seconds, then go to StopFire.
	stateName[4]                    = "Fire";
	stateTransitionOnTimeout[4]     = "StopFire";
	stateTimeoutValue[4]            = 0.5;
	stateFire[4]                    = true;
	stateAllowImageChange[4]        = false;
	stateSequence[4]                = "Fire";
	stateScript[4]                  = "onFire";
	stateWaitForTimeout[4]		= true;

	//play StopFire for 0.2 seconds, then go back to Ready state.
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";


};

function MonepunchImage::onFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
}

function MonepunchImage::onPostFire(%this, %obj, %slot)
{



	if(%obj.onepunching == 0)
	{
		//%obj.storedplayerdatablock = %obj.client.player.getDatablock();
		%obj.storedplayerdatablock = %obj.getDatablock();
		%obj.setDataBlock("PlayerPunch"); 
		%obj.onepunching = 1;
	}
	%obj.playthread(2, rotCCW);
	%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.getEyeVector(),"100"))); //rocket spammer
	//%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%user.getEyeVector(),"100"))); //rocket spammer
	//%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.client.player.getEyeVector(),"100"))); //rocket spammer
	%obj.addVelocity(0 SPC 0 SPC 2); //rocket spammer
}


function PlayerPunch::onCollision( %this, %obj, %col, %normal, %speed )
{ 
	
	parent::onCollision(%this, %obj, %col, %normal, %speed);
	if(isObject(%obj) && (%obj.onepunching == 1)) //gained from Visolator, March 16 2016. yay!
	//IF THE PLAYER EXISTS && IF THE "PUNCHING" IS ENABLED. (BY IF THE WEAPON IS BEING USED)
	{
	if(%col.getClassName() $= "Player" || %col.getClassName() $= "AIplayer")
	{ //IF WHAT YOU'RE COLLIDING WITH IS A PLAYER OR VEHICLE OR BOT
		
		if(minigameCanDamage(%obj, %col) && %col.getState() !$= "dead")
		//IF MINIGAME DAMAGE BETWEEN THE USER AND THE COLLIDER IS ENABLED && IF THE TARGET ISN'T DEAD
		{
			
			%col.spawnExplosion(MonepunchProjectile,1);
			%col.damage(%client, "0 0 0", %col.getDatablock().maxDamage - %col.getDamageLevel(), $DamageType::Melee);
		}
		%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.getEyeVector(),"100"))); //rocket spammer

	
	}
	}
}

function MonepunchImage::onStopFire(%this, %obj, %slot)
{	


//WHAT THE HECK I DOn'T NEED %OBJ.CLIENT.PLAYER??? I CAN JUST USE %OBJ??? WHAT IS THIS WITCHCRAFT WHAT THE HECK
	%obj.onepunching = 0;
	//%obj.client.player.setDataBlock(%obj.storedplayerdatablock); 
	%obj.setDataBlock(%obj.storedplayerdatablock); 
	%obj.playthread(2, root);
}






datablock PlayerData(PlayerPunch : PlayerStandardArmor)
{
	maxDamage = 999999; //health
	isInvincible = true;

	//maxItems = "10"; //how many bricks you can store, apparently
	maxTools = "9";
	maxWeapons = "9";

	runForce = 0 * 90;
	runEnergyDrain = 0;
	minRunEnergy = 0;
	maxForwardSpeed = 0;
	maxBackwardSpeed = 0;
	maxSideSpeed = 0;

	maxForwardCrouchSpeed = 0;
	maxBackwardCrouchSpeed = 0;
	maxSideCrouchSpeed = 0;

	maxUnderwaterForwardSpeed = "0";

	jumpForce = 200 * 90; //8.3 * 90;

	airControl = 0;

	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

	rechargeRate = 0;

	uiName = "";
	showEnergyBar = false;
};







//function PlayerPunch::onCollision( %this, %obj, %col, %normal, %speed )
//{ 
	
	//if(%obj.getClassName() $= "Player")
	//{
	//	%user = %obj;
	//}
	//if(%obj.getClassName() $= "AIPlayer")
	//{
	//	%user = %obj;
	//}

	//parent::onCollision(%this, %obj, %col, %normal, %speed);
	//if(isObject(%obj) && (%obj.punching == 1)) //gained from Visolator, March 16 2016. yay!
	//IF THE PLAYER EXISTS && IF THE "PUNCHING" IS ENABLED. (BY IF THE WEAPON IS BEING USED)
	//{
		//if(miniGameCanDamage(%obj) && isObject(%obj.client.minigame))) 
		//Don't touch it if it's involved in a different minigame
		//		continue;
		//oh yes. i got this. (%col.getClassName() $= "Player" || %col.getClassName() $= "AIplayer")
		//if(minigameCanDamage(%obj, %col) && %col.getState() !$= "dead")
		//IF MINIGAME DAMAGE BETWEEN THE USER AND THE COLLIDER IS ENABLED && IF THE TARGET ISN'T DEAD
		//{
		//	%col.spawnExplosion(MonepunchProjectile,1);
			//%col.addhealth(-10000);
		//	%col.damage(%client, "0 0 0", %col.getDatablock().maxDamage - %col.getDamageLevel(), $DamageType::Melee);
		//}

		//%obj.spawnExplosion(MonepunchProjectile,1);
	//%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.client.player.getEyeVector(),"100"))); //rocket spammer
	//%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.getEyeVector(),"100"))); //rocket spammer
	//%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.getEyeVector(),"100"))); //rocket spammer
	
	//} //I SCREWED IT UP NOW THE PLAYER CAN'T GRAB WEAPONS
	//okay this works decently i am DONE WITHOKND THIS DONE DONE DONE ODNETAKWGAg 
	//i will follow this with serveral minutes of cursing
//}
