//punch trail
datablock ParticleData(MtwopunchTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 2500;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//textureName		= "base/data/particles/corona2";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
	colors[0]	= "1 1 1 1.0";
	colors[1]	= "1 0.75 0.05 1.0";
	colors[2]	= "1 0.75 0.05 0.5";
	colors[3]	= "1 0.75 0.05 0.0";
	sizes[0]	= 0.1;
	sizes[1]	= 7;
	sizes[2]	= 4;
	sizes[3]	= 0;
	times[0]	= 0.0;
	times[1]	= 0.1;
	times[2]	= 0.7;
	times[3]	= 1.0;
};

datablock ParticleEmitterData(MtwopunchTrailEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = MtwopunchTrailParticle;
};




//projectile
datablock ProjectileData(MtwopunchProjectile)
{
   directDamage        = 10;
   impactImpulse       = 3000;
   verticalImpulse     = 1000;
   directDamageType  = $DamageType::Melee;
   radiusDamageType  = $DamageType::Melee;
   explosion           = MonepunchExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0.5 0 0";

   uiName = "Mtwopunch Punch";
};



//////////
// item //
//////////
datablock ItemData(MtwopunchItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "base/data/shapes/empty.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "MTwo Punch";
	iconName = "./icon_Mpunch";
	doColorShift = true;
	colorShiftColor = "1.000 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = MtwopunchImage;
	canDrop = false;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(MtwopunchImage)
{
   // Basic Item properties
   shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0.0 0.5 -0.75";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = MtwopunchItem;
   ammo = " ";
   projectile = MtwopunchProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.2;
	stateSequence[0]                = "Activate";
	stateTransitionOnTimeout[0]      = "Ready";

	//when the trigger is held go to prefire.
	stateName[1]                     = "Ready";
	stateSequence[1]                = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	//stateSequence[2]                = "Ready";
	//stateAllowImageChange[2]        = false;
	stateTransitionOnTriggerUp[2]	= "Fire";
	stateWaitForTimeout[2]		= true;
	stateTransitionOnTimeout[2]     = "PostFire";
	stateTimeoutValue[2]            = 0.05;

	//keeps cyling the PreFire thing.
	stateName[3]			= "PostFire";
	stateScript[3]                  = "onPostFire";
	stateSequence[3]                = "Ready";
	stateAllowImageChange[3]        = false;
	stateTransitionOnTriggerUp[3]	= "StopFire";
	stateWaitForTimeout[3]		= true;
	stateTransitionOnTimeout[3]     = "PostFire";
	stateTimeoutValue[3]            = 0.05;
   	stateEmitter[3]					= MtwopunchTrailEmitter;
	stateEmitterTime[3]				= 0.2;
	//stateEmitterNode[3]				= "muzzleNode";

//keeps cyling the PreFire thing.


	//fire the projectile for 0.2 seconds, then go to StopFire.
	stateName[4]                    = "Fire";
	stateTransitionOnTimeout[4]     = "StopFire";
	stateTimeoutValue[4]            = 0.5;
	stateFire[4]                    = true;
	stateAllowImageChange[4]        = false;
	stateSequence[4]                = "Fire";
	stateScript[4]                  = "onFire";
	stateWaitForTimeout[4]		= true;

	//play StopFire for 0.2 seconds, then go back to Ready state.
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";


};

function MtwopunchImage::onFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
}

function MtwopunchImage::onPostFire(%this, %obj, %slot)
{



	if(%obj.twopunching == 0)
	{
		//%obj.storedplayerdatablock = %obj.client.player.getDatablock();
		%obj.storedplayerdatablock = %obj.getDatablock();
		%obj.setDataBlock("PlayerPunchTwo"); 
		%obj.twopunching = 1;
	}
	%obj.playthread(2, rotCCW);
	%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.getEyeVector(),"50"))); //rocket spammer
	%obj.addVelocity(0 SPC 0 SPC 2); //rocket spammer
}


function PlayerPunchTwo::onCollision( %this, %obj, %col, %normal, %speed )
{ 
	
	parent::onCollision(%this, %obj, %col, %normal, %speed);
	if(isObject(%obj) && (%obj.twopunching == 1)) //gained from Visolator, March 16 2016. yay!
	//IF THE PLAYER EXISTS && IF THE "PUNCHING" IS ENABLED. (BY IF THE WEAPON IS BEING USED)
	{
	if(%col.getClassName() $= "Player" || %col.getClassName() $= "AIplayer")
	{ //IF WHAT YOU'RE COLLIDING WITH IS A PLAYER OR VEHICLE OR BOT
		if(minigameCanDamage(%obj, %col) && %col.getState() !$= "dead")
		//IF MINIGAME DAMAGE BETWEEN THE USER AND THE COLLIDER IS ENABLED && IF THE TARGET ISN'T DEAD
		{
			
			%col.spawnExplosion(MtwopunchProjectile,1);
			%col.damage(%client, "0 0 0", 50, $DamageType::Melee);
		}
		%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.getEyeVector(),"50"))); //rocket spammer

	
	}
	}
}

function MtwopunchImage::onStopFire(%this, %obj, %slot)
{	


//WHAT THE HECK I DOn'T NEED %OBJ.CLIENT.PLAYER??? I CAN JUST USE %OBJ??? WHAT IS THIS WITCHCRAFT WHAT THE HECK
	%obj.twopunching = 0;
	%obj.setDataBlock(%obj.storedplayerdatablock); 
	%obj.playthread(2, root);
}






datablock PlayerData(PlayerPunchTwo : PlayerStandardArmor)
{
	maxDamage = 250; //health
	//isInvincible = true;

	//maxItems = "10"; //how many bricks you can store, apparently
	maxTools = "9";
	maxWeapons = "9";

	runForce = 0 * 90;
	runEnergyDrain = 0;
	minRunEnergy = 0;
	maxForwardSpeed = 0;
	maxBackwardSpeed = 0;
	maxSideSpeed = 0;

	maxForwardCrouchSpeed = 0;
	maxBackwardCrouchSpeed = 0;
	maxSideCrouchSpeed = 0;

	maxUnderwaterForwardSpeed = "0";

	jumpForce = 1 * 90; //8.3 * 90;

	airControl = 0;

	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

	rechargeRate = 0;

	uiName = "";
	showEnergyBar = false;
};
